diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/node_context/node_updated.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/node_context/node_updated.inc
index 8b709cdf..60ac4b54 100644
--- a/drupal7/sites/all/modules/ctools/plugins/content_types/node_context/node_updated.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/node_context/node_updated.inc
@@ -20,7 +20,7 @@ $plugin = array(
  * Render the custom content type.
  */
 function ctools_node_updated_content_type_render($subtype, $conf, $panel_args, $context) {
-  if (empty($context) || empty($context->data)) {
+  if (empty($context) || empty($context->data) || empty($context->data->nid)) {
     return;
   }
 
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/page/page_site_name.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/page/page_site_name.inc
index 99501f2c..3053d451 100644
--- a/drupal7/sites/all/modules/ctools/plugins/content_types/page/page_site_name.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/page/page_site_name.inc
@@ -7,18 +7,48 @@
  */
 
 /**
- * Plugins are described by creating a $plugin array which will be used
- * by the system that includes this file.
+ * Plugins are described by creating a $plugin array which will be used by the
+ * system that includes this file.
  */
 $plugin = array(
   'title' => t('Site name'),
   'single' => TRUE,
   'icon' => 'icon_page.png',
-  'description' => t('The name of the site.'),
+  'description' => t('The name of the site, optionally links to the front page.'),
   'category' => t('Page elements'),
   'render last' => TRUE,
+  'defaults' => array(
+    'linked' => FALSE,
+  ),
 );
 
+/**
+ * Settings form for the Site Name pane.
+ */
+function ctools_page_site_name_content_type_edit_form($form, &$form_state) {
+  $conf = $form_state['conf'];
+
+  $form['linked'] = array(
+    '#title' => t('Linked'),
+    '#description' => t('Link the site name to the home page.'),
+    '#type' => 'checkbox',
+    '#default_value' => isset($conf['linked']) ? $conf['linked'] : FALSE,
+  );
+
+  return $form;
+}
+
+/**
+ * The submit form stores the data in $conf.
+ */
+function ctools_page_site_name_content_type_edit_form_submit($form, &$form_state) {
+  foreach (array_keys($form_state['plugin']['defaults']) as $key) {
+    if (isset($form_state['values'][$key])) {
+      $form_state['conf'][$key] = $form_state['values'][$key];
+    }
+  }
+}
+
 /**
  * Output function for the 'page_site_name' content type.
  *
@@ -26,7 +56,13 @@ $plugin = array(
  */
 function ctools_page_site_name_content_type_render($subtype, $conf, $panel_args) {
   $block = new stdClass();
+
   $block->content = filter_xss_admin(variable_get('site_name', 'Drupal'));
 
+  // Optionally link the site name to the homepage.
+  if (!empty($conf['linked'])) {
+    $block->content = l($block->content, '<front>');
+  }
+
   return $block;
 }
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/term_context/term_list.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/term_context/term_list.inc
index dc3124b1..7c609fb4 100644
--- a/drupal7/sites/all/modules/ctools/plugins/content_types/term_context/term_list.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/term_context/term_list.inc
@@ -11,7 +11,13 @@ $plugin = array(
   'description' => t('Terms related to an existing term; may be child, siblings or top level.'),
   'required context' => new ctools_context_required(t('Term'), array('term', 'taxonomy_term')),
   'category' => t('Taxonomy term'),
-  'defaults' => array('title' => '', 'type' => 'child', 'list_type' => 'ul', 'path' => 'taxonomy/term'),
+  'defaults' => array(
+    'title' => '',
+    'type' => 'child',
+    'include_current_term' => FALSE,
+    'list_type' => 'ul',
+    'path' => 'taxonomy/term',
+  ),
 );
 
 function ctools_term_list_content_type_render($subtype, $conf, $panel_args, $context) {
@@ -40,6 +46,9 @@ function ctools_term_list_content_type_render($subtype, $conf, $panel_args, $con
 
       case 'child':
       default:
+        if (!empty($conf['include_current_term'])) {
+          $terms[] = $term;
+        }
         $terms = taxonomy_get_children($term->tid);
         break;
 
@@ -49,6 +58,9 @@ function ctools_term_list_content_type_render($subtype, $conf, $panel_args, $con
 
       case 'parent':
         $terms = taxonomy_get_parents($term->tid);
+        if (!empty($conf['include_current_term'])) {
+          $terms[] = $term;
+        }
         $block->title = count($terms) == 1 ? t('Parent term') : t('Parent terms');
         break;
 
@@ -116,6 +128,20 @@ function ctools_term_list_content_type_edit_form($form, &$form_state) {
     '#suffix' => '</div>',
   );
 
+  $form['include_current_term'] = array(
+    '#type' => 'checkbox',
+    '#title' => t('Include the current term in the list'),
+    '#default_value' => !empty($conf['include_current_term']),
+    '#prefix' => '<div class="clearfix no-float">',
+    '#suffix' => '</div>',
+    '#states' => array(
+      'invisible' => array(
+        ':input[name="type"], unique1' => array('!value' => 'child'),
+        ':input[name="type"], unique2' => array('!value' => 'parent'),
+      ),
+    ),
+  );
+
   $form['list_type'] = array(
     '#type' => 'select',
     '#title' => t('List type'),
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/term_context/term_name.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/term_context/term_name.inc
new file mode 100644
index 00000000..a9a88764
--- /dev/null
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/term_context/term_name.inc
@@ -0,0 +1,121 @@
+<?php
+
+/**
+ * Plugins are described by creating a $plugin array which will be used
+ * by the system that includes this file.
+ */
+$plugin = array(
+  'single' => TRUE,
+  'title' => t('Term name'),
+  'icon' => 'icon_term.png',
+  'description' => t('The name of this taxonomy term.'),
+  'required context' => new ctools_context_required(t('Term'), array('term', 'taxonomy_term')),
+  'category' => t('Taxonomy term'),
+  'defaults' => array(
+    'link' => TRUE,
+    'markup' => 'none',
+    'id' => '',
+    'class' => '',
+  ),
+);
+
+
+/**
+ * Render the custom content type.
+ */
+function ctools_term_name_content_type_render($subtype, $conf, $panel_args, $context) {
+  if (empty($context) || empty($context->data)) {
+    return;
+  }
+
+  // Get a shortcut to the term.
+  $term = $context->data;
+
+  // Load the vocabulary.
+  $vocab = taxonomy_vocabulary_load($term->vid);
+
+  // Generate the title
+  $content = !empty($conf['link']) ? l($term->name, 'taxonomy/term/' . $term->tid) : check_plain($term->name);
+
+  // Build any surrounding markup if so configured
+  if (isset($conf['markup']) && $conf['markup'] != 'none') {
+    $markup = '<' . $conf['markup'];
+    if (!empty($conf['id'])) {
+      $markup .= ' id="' . $conf['id'] . '"';
+    }
+    if (!empty($conf['class'])) {
+      $markup .= ' class="' . $conf['class'] . '"';
+    }
+    $markup .= '>' . $content . '</' . $conf['markup'] . '>' . "\n";
+    $content = $markup;
+  }
+
+  // Build the content type block.
+  $block = new stdClass();
+  $block->module  = 'term_name';
+  $block->title   = t('Name');
+  $block->content = $content;
+  $block->delta   = $term->tid;
+
+  return $block;
+}
+
+/**
+ * Returns an edit form for custom type settings.
+ */
+function ctools_term_name_content_type_edit_form($form, &$form_state) {
+  $conf = $form_state['conf'];
+
+  $form['markup'] = array(
+    '#title' => t('Title tag'),
+    '#type' => 'select',
+    '#options' => array(
+      'none' => t('- No tag -'),
+      'h1' => t('h1'),
+      'h2' => t('h2'),
+      'h3' => t('h3'),
+      'h4' => t('h4'),
+      'h5' => t('h5'),
+      'h6' => t('h6'),
+      'div' => t('div'),
+    ),
+    '#default_value' => $conf['markup'],
+  );
+
+  $form['id'] = array(
+    '#title' => t('CSS id to use'),
+    '#type' => 'textfield',
+    '#default_value' => $conf['id'],
+  );
+
+  $form['class'] = array(
+    '#title' => t('CSS class to use'),
+    '#type' => 'textfield',
+    '#default_value' => $conf['class'],
+  );
+
+  $form['link'] = array(
+    '#title' => t('Link to term'),
+    '#type' => 'checkbox',
+    '#default_value' => $conf['link'],
+    '#description' => t('Check here to make the name link to the term page.'),
+  );
+  return $form;
+}
+
+/**
+ * Submit handler for the custom type settings form.
+ */
+function ctools_term_name_content_type_edit_form_submit($form, &$form_state) {
+  // Copy everything from our defaults.
+  foreach (array_keys($form_state['plugin']['defaults']) as $key) {
+    $form_state['conf'][$key] = $form_state['values'][$key];
+  }
+}
+
+/**
+ * Returns the administrative title for a type.
+ */
+function ctools_term_name_content_type_admin_title($subtype, $conf, $context) {
+  return t('"@s" name', array('@s' => $context->identifier));
+}
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/user_context/user_links.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/user_context/user_links.inc
new file mode 100644
index 00000000..4a93621d
--- /dev/null
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/user_context/user_links.inc
@@ -0,0 +1,84 @@
+<?php
+
+/**
+ * Plugins are described by creating a $plugin array which will be used
+ * by the system that includes this file.
+ */
+$plugin = array(
+  'single' => TRUE,
+  'title' => t('User links'),
+  'icon' => 'icon_user.png',
+  'description' => t('User links of the referenced user.'),
+  'required context' => new ctools_context_required(t('User'), 'user'),
+  'category' => t('User'),
+  'defaults' => array(
+    'override_title' => FALSE,
+    'override_title_text' => '',
+    'build_mode' => '',
+  ),
+);
+
+/**
+ * Output function for the user links.
+ */
+function ctools_user_links_content_type_render($subtype, $conf, $panel_args, $context) {
+  if (!empty($context) && empty($context->data)) {
+    return;
+  }
+
+  $account = clone $context->data;
+  $block = new stdClass();
+  $block->module = 'user';
+  $block->delta  = $account->uid;
+
+  if (empty($account)) {
+    $block->delta   = 'placeholder';
+    $block->subject = t('User name.');
+    $block->content = t('User links go here.');
+  }
+  else {
+    $block->subject = $account->name;
+    user_build_content($account, $conf['build_mode']);
+    if (!empty($account->content['links'])) {
+      $block->content = $account->content['links'];
+    }
+    else {
+      $block->content = '';
+    }
+  }
+  return $block;
+}
+
+/**
+ * Returns an edit form for the custom type.
+ */
+function ctools_user_links_content_type_edit_form($form, &$form_state) {
+  $conf = $form_state['conf'];
+
+  $entity = entity_get_info('user');
+  $build_mode_options = array();
+  foreach ($entity['view modes'] as $mode => $option) {
+    $build_mode_options[$mode] = $option['label'];
+  }
+
+  $form['build_mode'] = array(
+    '#title' => t('Build mode'),
+    '#type' => 'select',
+    '#description' => t('Select a build mode for this user.'),
+    '#options' => $build_mode_options,
+    '#default_value' => $conf['build_mode'],
+  );
+
+  return $form;
+}
+
+function ctools_user_links_content_type_edit_form_submit($form, &$form_state) {
+  // Copy everything from our defaults.
+  foreach (array_keys($form_state['plugin']['defaults']) as $key) {
+    $form_state['conf'][$key] = $form_state['values'][$key];
+  }
+}
+
+function ctools_user_links_content_type_admin_title($subtype, $conf, $context) {
+  return t('"@s" links', array('@s' => $context->identifier));
+}
diff --git a/drupal7/sites/all/modules/ctools/plugins/contexts/string.inc b/drupal7/sites/all/modules/ctools/plugins/contexts/string.inc
index 9a715b89..e731ab74 100644
--- a/drupal7/sites/all/modules/ctools/plugins/contexts/string.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/contexts/string.inc
@@ -22,6 +22,7 @@ $plugin = array(
   'convert list' => array(
     'raw' => t('Raw string'),
     'html_safe' => t('HTML-safe string'),
+    'uppercase_words_html_safe' => t('Uppercase words HTML-safe string'),
   ),
   'convert' => 'ctools_context_string_convert',
   'placeholder form' => array(
@@ -62,6 +63,8 @@ function ctools_context_string_convert($context, $type) {
       return $context->data;
     case 'html_safe':
       return check_plain($context->data);
+    case 'uppercase_words_html_safe':
+      return ucwords(str_replace('-', ' ', check_plain($context->data)));
   }
 }
 
diff --git a/drupal7/sites/all/modules/ctools/plugins/contexts/user.inc b/drupal7/sites/all/modules/ctools/plugins/contexts/user.inc
index 638d146f..02bfe987 100644
--- a/drupal7/sites/all/modules/ctools/plugins/contexts/user.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/contexts/user.inc
@@ -88,7 +88,7 @@ function ctools_context_user_settings_form($form, &$form_state) {
   if (!empty($conf['uid'])) {
     $info = user_load($conf['uid']);
     if ($info) {
-      $form['user']['#description'] = t('Currently set to !link', array('!link' => theme('username', $info)));
+      $form['user']['#description'] = t('Currently set to !link', array('!link' => theme('username', array('account' => $info))));
     }
   }
 
diff --git a/drupal7/sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php b/drupal7/sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php
index 1048e199..252cdb11 100644
--- a/drupal7/sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php
+++ b/drupal7/sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php
@@ -121,7 +121,7 @@ class ctools_export_ui {
 
     switch ($op) {
       case 'import':
-        return user_access('use PHP for settings');
+        return user_access('use ctools import');
       case 'revert':
         return ($item->export_type & EXPORT_IN_DATABASE) && ($item->export_type & EXPORT_IN_CODE);
       case 'delete':
@@ -639,7 +639,7 @@ class ctools_export_ui {
   }
 
   function add_page($js, $input, $step = NULL) {
-    drupal_set_title($this->get_page_title('add'));
+    drupal_set_title($this->get_page_title('add'), PASS_THROUGH);
 
     // If a step not set, they are trying to create a new item. If a step
     // is set, they're in the process of creating an item.
@@ -676,7 +676,7 @@ class ctools_export_ui {
    * Main entry point to edit an item.
    */
   function edit_page($js, $input, $item, $step = NULL) {
-    drupal_set_title($this->get_page_title('edit', $item));
+    drupal_set_title($this->get_page_title('edit', $item), PASS_THROUGH);
 
     // Check to see if there is a cached item to get if we're using the wizard.
     if (!empty($this->plugin['use wizard'])) {
@@ -712,7 +712,7 @@ class ctools_export_ui {
    * Main entry point to clone an item.
    */
   function clone_page($js, $input, $original, $step = NULL) {
-    drupal_set_title($this->get_page_title('clone', $original));
+    drupal_set_title($this->get_page_title('clone', $original), PASS_THROUGH);
 
     // If a step not set, they are trying to create a new clone. If a step
     // is set, they're in the process of cloning an item.
@@ -1218,7 +1218,7 @@ class ctools_export_ui {
    * Page callback to display export information for an exportable item.
    */
   function export_page($js, $input, $item) {
-    drupal_set_title($this->get_page_title('export', $item));
+    drupal_set_title($this->get_page_title('export', $item), PASS_THROUGH);
     return drupal_get_form('ctools_export_form', ctools_export_crud_export($this->plugin['schema'], $item), t('Export'));
   }
 
@@ -1226,7 +1226,7 @@ class ctools_export_ui {
    * Page callback to import information for an exportable item.
    */
   function import_page($js, $input, $step = NULL) {
-    drupal_set_title($this->get_page_title('import'));
+    drupal_set_title($this->get_page_title('import'), PASS_THROUGH);
     // Import is basically a multi step wizard form, so let's go ahead and
     // use CTools' wizard.inc for it.
 
@@ -1339,7 +1339,7 @@ function _ctools_export_ui_add_form_files($form, &$form_state) {
  *
  * This simply loads the object defined in the plugin and hands it off.
  */
-function ctools_export_ui_list_form($form, $form_state) {
+function ctools_export_ui_list_form($form, &$form_state) {
   $form_state['object']->list_form($form, $form_state);
   return $form;
 }
diff --git a/drupal7/sites/all/modules/ctools/stylizer/stylizer.info b/drupal7/sites/all/modules/ctools/stylizer/stylizer.info
index 9acbe737..d73a641d 100644
--- a/drupal7/sites/all/modules/ctools/stylizer/stylizer.info
+++ b/drupal7/sites/all/modules/ctools/stylizer/stylizer.info
@@ -2,12 +2,13 @@ name = Stylizer
 description = Create custom styles for applications such as Panels.
 core = 7.x
 package = Chaos tool suite
+version = CTOOLS_MODULE_VERSION
 dependencies[] = ctools
 dependencies[] = color
 
-; Information added by Drupal.org packaging script on 2014-11-19
-version = "7.x-1.5"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-1.6"
 core = "7.x"
 project = "ctools"
-datestamp = "1416423525"
+datestamp = "1422471484"
 
diff --git a/drupal7/sites/all/modules/ctools/term_depth/term_depth.info b/drupal7/sites/all/modules/ctools/term_depth/term_depth.info
index 0b035582..5f4ef707 100644
--- a/drupal7/sites/all/modules/ctools/term_depth/term_depth.info
+++ b/drupal7/sites/all/modules/ctools/term_depth/term_depth.info
@@ -3,9 +3,11 @@ description = Controls access to context based upon term depth
 core = 7.x
 dependencies[] = ctools
 package = Chaos tool suite
-; Information added by Drupal.org packaging script on 2014-11-19
-version = "7.x-1.5"
+version = CTOOLS_MODULE_VERSION
+
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-1.6"
 core = "7.x"
 project = "ctools"
-datestamp = "1416423525"
+datestamp = "1422471484"
 
diff --git a/drupal7/sites/all/modules/ctools/tests/css_cache.test b/drupal7/sites/all/modules/ctools/tests/css_cache.test
new file mode 100644
index 00000000..e289b42c
--- /dev/null
+++ b/drupal7/sites/all/modules/ctools/tests/css_cache.test
@@ -0,0 +1,48 @@
+<?php
+/**
+ * @file
+ * Tests the custom CSS cache handler.
+ */
+
+/**
+ * Tests the custom CSS cache handler.
+ */
+class CtoolsObjectCache extends DrupalWebTestCase {
+
+  /**
+   * {@inheritdoc}
+   */
+  public static function getInfo() {
+    return array(
+      'name' => 'Ctools CSS cache',
+      'description' => 'Tests the custom CSS cache handler.',
+      'group' => 'Chaos Tools Suite',
+    );
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  public function setUp() {
+    parent::setUp('ctools');
+  }
+
+  /**
+   * Tests the custom CSS cache handler.
+   *
+   * @see https://drupal.org/node/1313368
+   */
+  public function testCssCache() {
+    // Create a CSS cache entry.
+    $filename = ctools_css_cache('body { color: red; }');
+
+    // Perform a cron run. The CSS cache entry should not be removed.
+    $this->cronRun();
+    $this->assertTrue(file_exists($filename), 'The CSS cache is not cleared after performing a cron run.');
+
+    // Manually clear the caches. The CSS cache entry should be removed.
+    drupal_flush_all_caches();
+    $this->assertFalse(file_exists($filename), 'The CSS cache is cleared after clearing all caches.');
+  }
+
+}
diff --git a/drupal7/sites/all/modules/ctools/tests/ctools_export_test/ctools_export_test.info b/drupal7/sites/all/modules/ctools/tests/ctools_export_test/ctools_export_test.info
index dfc023e7..86cd3220 100644
--- a/drupal7/sites/all/modules/ctools/tests/ctools_export_test/ctools_export_test.info
+++ b/drupal7/sites/all/modules/ctools/tests/ctools_export_test/ctools_export_test.info
@@ -2,14 +2,15 @@ name = CTools export test
 description = CTools export test module
 core = 7.x
 package = Chaos tool suite
+version = CTOOLS_MODULE_VERSION
 dependencies[] = ctools
 hidden = TRUE
 
 files[] = ctools_export.test
 
-; Information added by Drupal.org packaging script on 2014-11-19
-version = "7.x-1.5"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-1.6"
 core = "7.x"
 project = "ctools"
-datestamp = "1416423525"
+datestamp = "1422471484"
 
diff --git a/drupal7/sites/all/modules/ctools/tests/ctools_plugin_test.info b/drupal7/sites/all/modules/ctools/tests/ctools_plugin_test.info
index 955f2063..f2b5cc89 100644
--- a/drupal7/sites/all/modules/ctools/tests/ctools_plugin_test.info
+++ b/drupal7/sites/all/modules/ctools/tests/ctools_plugin_test.info
@@ -1,6 +1,7 @@
 name = Chaos tools plugins test
 description = Provides hooks for testing ctools plugins.
 package = Chaos tool suite
+version = CTOOLS_MODULE_VERSION
 core = 7.x
 dependencies[] = ctools
 files[] = ctools.plugins.test
@@ -11,9 +12,9 @@ files[] = math_expression.test
 files[] = math_expression_stack.test
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-11-19
-version = "7.x-1.5"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-1.6"
 core = "7.x"
 project = "ctools"
-datestamp = "1416423525"
+datestamp = "1422471484"
 
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc
index 262d81de..bb413d5b 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc
@@ -63,18 +63,6 @@ function views_content_views_content_type_content_types($plugin) {
   return $types;
 }
 
-/**
- * Return a single content type.
- */
-function views_content_views_content_type_content_type($subtype, $plugin) {
-  $view = views_get_view($name);
-  if (empty($view)) {
-    return;
-  }
-
-  return _views_content_views_content_type($view);
-}
-
 /**
  * Create the content type info array to give back to ctools for a given display.
  */
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc
index b77404e6..dc61bca9 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc
@@ -274,6 +274,11 @@ function views_content_views_panes_content_type_render($subtype, $conf, $panel_a
   }
 
   if ($allow['exposed_form'] && !empty($conf['exposed'])) {
+    foreach ($conf['exposed'] as $filter_name => $filter_value) {
+      if (!is_array($filter_value)) {
+        $conf['exposed'][$filter_name] = ctools_context_keyword_substitute($filter_value, array(), $contexts);
+      }
+    }
     $view->set_exposed_input($conf['exposed']);
   }
 
@@ -284,6 +289,11 @@ function views_content_views_panes_content_type_render($subtype, $conf, $panel_a
     return;
   }
 
+  // Add contextual links to the output.
+  $block = (array) $block;
+  views_add_block_contextual_links($block, $view, $display, 'panel_pane');
+  $block = (object) $block;
+
   $block->title = $view->get_title();
 
   if (empty($view->total_rows) || $view->total_rows <= $view->get_items_per_page()) {
@@ -313,7 +323,7 @@ function views_content_views_panes_add_defaults(&$conf, $view) {
 
   $conf += array(
     'link_to_view' => $view->display_handler->get_option('link_to_view'),
-    'more_link' => $view->display_handler->get_option('more_link'),
+    'more_link' => $view->display_handler->get_option('use_more'),
     'feed_icons' => FALSE,
     'use_pager' => $pager['type'] != 'none' && $pager['type'] != 'some',
     'pager_id' => isset($pager['options']['id']) ? $pager['options']['id'] : 0,
@@ -408,7 +418,7 @@ function views_content_views_panes_content_type_edit_form($form, &$form_state) {
       $form['fields_override'][$field] = array(
         '#type' => 'checkbox',
         '#title' => $title,
-        '#default_value' => isset($conf['fields_override'][$field]) ? $conf['fields_override'][$field] : TRUE,
+        '#default_value' => isset($conf['fields_override'][$field]) ? $conf['fields_override'][$field] : !$handler->options['exclude'],
       );
     }
   }
@@ -602,7 +612,7 @@ function views_content_views_panes_content_type_admin_info($subtype, $conf, $con
     $argument_input = $view->display_handler->get_option('argument_input');
 
     foreach ($conf['arguments'] as $key => $value) {
-      if(!empty($value)){
+      if (!empty($value)){
         $label = $argument_input[$key]['label'];
         $info[] = $label . ': ' . $value;
       }
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/relationships/term_from_view.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/relationships/term_from_view.inc
index bdd25b85..fc9e20d4 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/relationships/term_from_view.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/relationships/term_from_view.inc
@@ -13,7 +13,7 @@ $plugin = array(
   'title' => t('Term from view'),
   'keyword' => 'term',
   'description' => t('Extract a term context from a view context of the base type term.'),
-  'required context' => new ctools_context_required(t('View'), 'view', array('base' => 'term_data')),
+  'required context' => new ctools_context_required(t('View'), 'view', array('base' => 'taxonomy_term_data')),
   'context' => 'views_content_term_from_view_context',
   'edit form' => 'views_content_term_from_view_settings_form',
   'edit form validate' => 'views_content_term_from_view_settings_form_validate',
@@ -26,7 +26,7 @@ $plugin = array(
 function views_content_term_from_view_context($context, $conf, $placeholder = FALSE) {
   // If unset it wants a generic, unfilled context, which is just NULL.
   if (empty($context->data) || $placeholder) {
-    return ctools_context_create_empty('term', NULL);
+    return ctools_context_create_empty('entity:taxonomy_term', NULL);
   }
   $view = views_content_context_get_view($context);
   // Ensure the view executes, but we don't need its output.
@@ -36,11 +36,11 @@ function views_content_term_from_view_context($context, $conf, $placeholder = FA
   if (isset($view->result[$row])) {
     $tid = $view->result[$row]->{$view->base_field};
     if ($tid) {
-      $term = taxonomy_get_term($tid);
-      return ctools_context_create('term', $term);
+      $term = taxonomy_term_load($tid);
+      return ctools_context_create('entity:taxonomy_term', $term);
     }
   }
-  return ctools_context_create_empty('term', NULL);
+  return ctools_context_create_empty('entity:taxonomy_term', NULL);
 }
 
 /**
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content.views.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content.views.inc
index 6724d3c5..644ac547 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content.views.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content.views.inc
@@ -25,6 +25,7 @@ function views_content_views_plugins() {
         'use more' => TRUE,
         'accept attachments' => TRUE,
         'help topic' => 'display-pane',
+        'contextual links locations' => array('panel_pane'),
       ),
       'ctools_context' => array(
         'title' => t('Context'),
diff --git a/drupal7/sites/all/modules/ctools/views_content/views_content.info b/drupal7/sites/all/modules/ctools/views_content/views_content.info
index 2d67e974..be820842 100644
--- a/drupal7/sites/all/modules/ctools/views_content/views_content.info
+++ b/drupal7/sites/all/modules/ctools/views_content/views_content.info
@@ -5,13 +5,14 @@ dependencies[] = ctools
 dependencies[] = views
 core = 7.x
 package = Chaos tool suite
+version = CTOOLS_MODULE_VERSION
 files[] = plugins/views/views_content_plugin_display_ctools_context.inc
 files[] = plugins/views/views_content_plugin_display_panel_pane.inc
 files[] = plugins/views/views_content_plugin_style_ctools_context.inc
 
-; Information added by Drupal.org packaging script on 2014-11-19
-version = "7.x-1.5"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-1.6"
 core = "7.x"
 project = "ctools"
-datestamp = "1416423525"
+datestamp = "1422471484"
 
diff --git a/drupal7/sites/all/modules/ctools/views_content/views_content.module b/drupal7/sites/all/modules/ctools/views_content/views_content.module
index e5074f5f..27a666ae 100644
--- a/drupal7/sites/all/modules/ctools/views_content/views_content.module
+++ b/drupal7/sites/all/modules/ctools/views_content/views_content.module
@@ -281,3 +281,17 @@ function _views_content_get_context_from_display($view, $id, $parent, $required
     'view display id' => $id,
   );
 }
+
+/**
+ * Implements hook_get_pane_links_alter().
+ */
+function views_content_get_pane_links_alter(&$links, $pane, $content_type) {
+  if ($pane->type === 'views_panes') {
+    list($view_name, $display_name) = explode('-', $pane->subtype);
+    $destination = array('destination' => current_path());
+    $links['top'][] = array(
+      'title' => t('Edit view'),
+      'href' => url('admin/structure/views/view/' . $view_name . '/edit/' . $display_name, array('query' => $destination, 'absolute' => TRUE)),
+    );
+  }
+}
diff --git a/drupal7/sites/all/modules/i18n/i18n.info b/drupal7/sites/all/modules/i18n/i18n.info
index cbc64cc6..d4f5c430 100644
--- a/drupal7/sites/all/modules/i18n/i18n.info
+++ b/drupal7/sites/all/modules/i18n/i18n.info
@@ -8,9 +8,9 @@ files[] = i18n_object.inc
 files[] = i18n.test
 configure = admin/config/regional/i18n
 
-; Information added by Drupal.org packaging script on 2014-04-16
-version = "7.x-1.11"
+; Information added by Drupal.org packaging script on 2015-01-26
+version = "7.x-1.12"
 core = "7.x"
 project = "i18n"
-datestamp = "1397666996"
+datestamp = "1422286982"
 
diff --git a/drupal7/sites/all/modules/i18n/i18n.module b/drupal7/sites/all/modules/i18n/i18n.module
index e94dd83b..b65061dc 100644
--- a/drupal7/sites/all/modules/i18n/i18n.module
+++ b/drupal7/sites/all/modules/i18n/i18n.module
@@ -403,9 +403,17 @@ function i18n_get_object($type, $key, $object = NULL) {
   $index = is_array($key) ? implode(':', $key) : $key;
   if (!isset($cache[$type][$index])) {
     $class = i18n_object_info($type, 'class', 'i18n_object_wrapper');
-    $cache[$type][$index] = new $class($type, $key, $object);
+    $object_wrapper = new $class($type, $key, $object);
+    // Do not cache object with empty index.
+    if (!empty($index)) {
+      $cache[$type][$index] = $object_wrapper;
+    }
+  }
+  else {
+    $object_wrapper = $cache[$type][$index];
   }
-  return $cache[$type][$index];
+
+  return $object_wrapper;
 }
 
 /**
diff --git a/drupal7/sites/all/modules/i18n/i18n_block/i18n_block.info b/drupal7/sites/all/modules/i18n/i18n_block/i18n_block.info
index bf910a1d..0e599035 100644
--- a/drupal7/sites/all/modules/i18n/i18n_block/i18n_block.info
+++ b/drupal7/sites/all/modules/i18n/i18n_block/i18n_block.info
@@ -8,9 +8,9 @@ files[] = i18n_block.inc
 files[] = i18n_block.test
 
 
-; Information added by Drupal.org packaging script on 2014-04-16
-version = "7.x-1.11"
+; Information added by Drupal.org packaging script on 2015-01-26
+version = "7.x-1.12"
 core = "7.x"
 project = "i18n"
-datestamp = "1397666996"
+datestamp = "1422286982"
 
